const state = {
    suppliers: {
        default: [],
        values: this.default
    },
    filteredSuppliers: {
        default: [],
        values: this.default
    },
    selectedSupplier: {
        default: null,
        value: this.default
    },
    addSupplier: {
        default: false,
        value: this.default
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    suppliers(state) {
        return state.suppliers.values
    },
    /**
     * 
     * @param {*} state 
     */
    hasSelectedSupplier(state) {
        return !!state.selectedSupplier.value
    },
    /**
     * 
     * @param {*} state 
     */
    selectedSupplier(state) {
        return state.selectedSupplier.value
    },
    /**
     * 
     * @param {*} state 
     */
    addSupplier(state) {
        return state.addSupplier.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSuppliers(state, payload) {
        state.suppliers.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSelectedSupplier(state, payload) {
        state.selectedSupplier.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setFilteredSuppliers(state, payload) {
        state.filteredSuppliers.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     */
    setAddSupplier(state, payload) {
        state.addSupplier.value = payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     */
    setSuppliers({ commit }, payload) {
        commit('setSuppliers', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    setSelectSupplier({ commit }, payload) {
        commit('selectSupplier', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    setFilteredSuppliers({ commit }, payload) {
        commit('filterSuppliers', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    setAddSupplier({ commit }) {
        commit('addSupplier')
    },
    /**
     * 
     * @param {*} param0 
     */
    pushSupplier({ commit, dispatch }) {
        console.log('push')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}